#hardcode if you're not in the correct package instance...

#set package_id [ad_conn package_id]
set package_id 3061

#hardcode regexp for link replacement
#... later

set olddb [ns_db gethandle acs32]

set n_tried_old 0

set selection [ns_db select $olddb " 
select distinct category, topic_id from bboard
where bboard.category is not null
order by topic_id, category
"]

set forum_mapping_sql "
select new_forum_id from migr_forum_map
where old_forum_id = :topic_id 
  and package_id = :package_id"


set mapped_category_sql   "
select old_category as old_map_id,
new_category_id as new_map_id 
from migr_category_map where old_category=:category"

set map_category_sql "
insert into migr_category_map
(old_category, new_category_id, package_id, new_forum_id)
values
(:category, :new_id, :package_id, :new_forum_id)
"



set nil [set new [list]]
set output ""

db_transaction {
while { [ns_db getrow $olddb $selection] } {
    set_variables_after_query
    
    #also lookup forum mapping
    db_1row q $forum_mapping_sql

    incr n_tried_old

    if [db_0or1row r $mapped_category_sql] {
	##already mapped as well, sets new_map_id, old_map_id
	set new_id $new_map_id
	set action "nil"
    } else {
	set new_created_id [bboard_category_new -short_name $category \
            -forum_id $new_forum_id]

	set new_id $new_created_id
	set action "new"
	db_dml q $map_category_sql
    }

    set html "
    $category => $new_id (forum $new_forum_id)  
     <br>"

    lappend $action $html
    
    append output "<b>$action</b>:  $html"

}
} on_error {
    set output "<h3>Error:</h3><pre>$errmsg</pre><br><br>$output"
}

ns_db releasehandle $olddb
    
ns_return 200 text/html "<html>
<head><title>Migratonicategory</title></head>
<body><h3> Migrating Categorys</h3><p>
<h3>Unsorted Output:</h3>$output<br><h3>Sorted Output:</h3>
<h3>[llength $nil] nil -- categorys already created & mapped</h3><p>[join $nil]</p>
<h3>[llength $new] new -- uncreated and unmapped</h3><p>[join $new]</p>
</body></html>
"


    
    
