#hardcode if you're not in the correct package instance...

#set package_id [ad_conn package_id]
set package_id 3409

set olddb [ns_db gethandle acs32]

set n_tried_old 0

set selection [ns_db select $olddb " 
select * from bboard order by msg_id"]

set mapped_message_sql   "
select old_message_id as old_map_id,
new_message_id as new_map_id 
from migr_message_map where old_message_id=:msg_id"


set nil [set new [list]]
set output ""

db_transaction {
    while { [ns_db getrow $olddb $selection] } {
	set_variables_after_query
	incr n_tried_old

	#topic/forum
	db_1row q "select new_forum_id from migr_forum_map
	where old_forum_id = :topic_id and package_id = :package_id"

	if [db_0or1row tt $mapped_message_sql] {

	    ##already mapped, sets new_map_id, old_map_id
	    set new_id $new_map_id
	    set action "nil"
	} else {

	    #lookups:
	    #user
	    db_1row q "select new_user_id from migr_user_map
	    where old_user_id = :user_id"

	    #thread
	    if {![empty_string_p $refers_to]} {
		db_1row q "select new_message_id as new_reply_to_id
		from migr_message_map
		where old_message_id = :refers_to
		  and package_id = :package_id"
	    } else {
		set new_reply_to_id ""
	    }
	    
	    #mime
	    if {$html_p == "t"} {
		set mime_type "text/html"
	    } else {
		set mime_type "text/plain; format=flowed"
	    }
	    
	set new_created_id [bboard_message_new -reply_to $new_reply_to_id \
		-sender $new_user_id -title $one_line -mime_type $mime_type \
		-content $message -context_id $new_forum_id \
		-creation_ip $originating_ip \
		-sent_date $posting_time
]

	    bboard_message_set_status \
		    -message_id $new_created_id \
		    -forum_id $new_forum_id -status "unmoderated"

	    if {![empty_string_p $category]} {
		db_1row q "select category_id as new_category_id
		from bboard_categories
		where short_name = '$category' 
		  and forum_id=$new_forum_id"

		db_dml q "insert into bboard_category_message_map
		(message_id, category_id)
		values (:new_created_id, :new_category_id)"

	    }


	    db_dml q "insert into migr_message_map 
	    (old_message_id, new_message_id, package_id) 
	    values 
	    ('$msg_id', $new_created_id, $package_id)"
	    
	    set new_id $new_created_id
	    set action "new"
	}

	set html "
	$msg_id => $new_id (forum $new_forum_id):  
	$one_line <br>"
	
	lappend $action $html
	
	append output "<b>$action</b>:  $html"
    }
} on_error {
    set output "<h3>Error:</h3><pre>$errmsg</pre><br>
    $msg_id t $topic_id r $refers_to rid $new_reply_to_id u $user_id p $package_id: $one_line
 c $category id $new_category_id"
#  : a $action"
#    <br>$output"
}

ns_db releasehandle $olddb
    
ns_return 200 text/html "<html>
<head><title>Migratonicmessage</title></head>
<body><h3> Migrating Messages</h3><p>
<h3>Unsorted Output:</h3>$output<br><h3>Sorted Output:</h3>
<h3>[llength $nil] nil -- messages already created & mapped</h3><p>[join $nil]</p>
<h3>[llength $new] new -- uncreated and unmapped</h3><p>[join $new]</p>
</body></html>
"


    
    
