#hardcode if you're not in the correct package instance...

# which package are we using
#set bboard_package "bboard"
set bboard_package "forums"

#set package_id [ad_conn package_id]
set package_id 3061

set olddb [ns_db gethandle acs32]

set n_tried_old 0

set selection [ns_db select $olddb " 
select user_id, topic_id, frequency from bboard_email_alerts
order by topic_id"]

set forum_mapping_sql "
select new_forum_id from migr_forum_map
where old_forum_id = :topic_id 
  and package_id = :package_id"

set user_mapping_sql "
select new_user_id from migr_user_map
where old_user_id = :user_id 
"


#note: no migr_map neccessary for subscriptions
# or even possible -- covered by user and topic map

if {[string equal $bboard_package "bboard"]} {
    set mapped_subs_sql  "
    select forum_id || '-' || subscriber_id as new_map_id
     from bboard_forum_subscribers
    where forum_id = :new_forum_id
    and subscriber_id = :new_user_id"

    set map_subs_sql "
    insert into bboard_forum_subscribers
    (forum_id, subscriber_id) values 
    (:new_forum_id, :new_user_id)"

    set id_description "forum-user"

} else {
    # assume it's the new "forums" package 

    set type_id [notification::type::get_type_id -short_name forums_forum_notif]
    set delivery_method_id [notification::get_delivery_method_id -name "email"]

    set mapped_subs_sql  "
            select request_id as new_map_id
            from notification_requests 
            where type_id = :type_id 
            and user_id = :new_user_id 
            and object_id = :new_forum_id 
"

    set id_description "request_id"
}


set nil [set new [list]]
set output ""

while { [ns_db getrow $olddb $selection] } {
    set_variables_after_query
	
    db_transaction {
	#also lookup forum and user mapping
	db_1row q $forum_mapping_sql
	db_1row q $user_mapping_sql
	
	incr n_tried_old
	if [db_0or1row r $mapped_subs_sql] {
	    ##already mapped, sets new_map_id
	    set new_id $new_map_id
	    set action "nil"
	} else {
	    #it's new; insert it.
	    if {[string equal $bboard_package "bboard"]} {
		#TODO: add notification frequency migr code (olah)
		db_dml q $map_subs_sql
	    } else {
		# assume it's the new "forums" package
		if {[string equal $frequency "Monday/Thursday"]} {
		    set frequency "every other day"
		}
		set interval_id [notification::get_interval_id \
		    -name $frequency]
		set request_id [notification::request::new -type_id $type_id \
		    -user_id $new_user_id -object_id $new_forum_id \
		    -interval_id $interval_id \
		    -delivery_method_id $delivery_method_id -format "text"]

	    }
	    set new_id "$new_forum_id-$new_user_id"
	    set action "new"
	}
	
	set html "
        $id_description: $new_id
        <br>"

	lappend $action $html
    
	append output "<b>$action</b>:  $html"
    } on_error {
	set output "<h3>Error:</h3><pre>$errmsg</pre><br><br>$output"
    }
}

ns_db releasehandle $olddb
    
ns_return 200 text/html "<html>
<head><title>Migratonisubscripforum</title></head>
<body><h3> Migrating Forum Subscrtiptions</h3><p>
<h3>Unsorted Output:</h3>$output<br><h3>Sorted Output:</h3>
<h3>[llength $nil] nil -- subscriptions already created & mapped</h3><p>[join $nil]</p>
<h3>[llength $new] new -- uncreated and unmapped</h3><p>[join $new]</p>
</body></html>
"


    
    
